
Redmine - Patch #986

Clone remote git repository

2008-04-03 19:27 - Michael Bumann

Status: Closed Start date: 2008-04-03

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Description

this patch clones the repository of a remote GIT repository.

enter the public clone URL (git://..../.git) it will clone it to RAILS_ROOT/repositories/git/<project identifier>/<repository name>

It also changes the URL to use the local clone.

Related issues:

Related to Redmine - Feature #2580: Remote git repositories Closed 2009-01-25

Related to Redmine - Feature #6515: Mercurial hgrc support with issues auto-s... New 2010-09-28

Related to Redmine - Patch #1783: automatic repository creation New 2008-08-13

Related to Redmine - Patch #7494: Patch for support http protocol wirh mercur... Closed 2011-01-30 2011-01-30

History

#1 - 2008-04-07 20:10 - Jean-Philippe Lang

- Target version deleted (0.7)

#2 - 2008-07-05 15:42 - Thomas Lecavelier

Test cases are missing. I know it wouldn't be easy but you can try to accept "not so remote" repository in tmp dir.

Not tested, but the dir variable in the diff could break if white spaces appear: please protect this var expansion in the command line with simple

quotes.

#3 - 2011-12-16 13:28 - Toshi MARUYAMA

- Status changed from New to Closed

As I described #7494 note 2,

I think Redmine core should not have this feature.

It is impossible to test.

Plugins should provide this feature.

#4 - 2012-04-05 11:31 - Gabriel Mazetto

Toshi MARUYAMA wrote:

As I described #7494 note 2,

I think Redmine core should not have this feature.

It is impossible to test.

Plugins should provide this feature.

 It is not impossible, it can be a little tricky, but still really possible. A easy test case could be: get a dummy git bare repository in the test folder, then

run git-daemon configured to provide this dummy repository. The unit test will have to add a repository from git://localhost/1.git (for example) and then

check to see if the folder was correctly created and if it's a git repository.

Also there is the "git" rubygem  that can make it easy to clone and fetch revisions:

require 'git'

Git.clone('git://github.com/.../repo.git', '/destination/path.git', :bare => true)

 and

git = Git.open('/destination/path.git', :log => Logger.new(STDOUT))

git.fetch('origin')

 It can't be easier then that. Implementing this "feature" will make redmine usable with git.
clone_remote_git.diff 1.68 KB 2008-04-03 Michael Bumann
